Unit Base64;

Interface

Function EncodeBase64(Const inStr:String):String;
Function EncodeBase64Mas(inStr:Array Of Byte):String;
Function DecodeBase64(Const CinLine:String):String;
Procedure DecodeBase64Mas(Const CinLine:String;Var InStr:Array Of Byte);

Implementation

Function Encode_Byte(B:Byte):Char;
Const
  Base64Code: string[64]='ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
Begin
  Result:=Base64Code[(B And $3F)+1];
End;

Function EncodeBase64(Const inStr:String):String;
Var
  I:Integer;
Begin
  I:=1;
  Result:='';
  While I<=Length(InStr) Do
  Begin
    Result := Result + Encode_Byte(Byte(inStr[i]) shr 2);
    Result := Result + Encode_Byte((Byte(inStr[i]) shl 4) or (Byte(inStr[i+1]) shr 4));
    If I+1<=Length(inStr) then
      Result := Result + Encode_Byte((Byte(inStr[i+1]) shl 2) or (Byte(inStr[i+2]) shr 6))
    else
      Result := Result + '=';
    if i+2<=Length(inStr) then
      Result := Result + Encode_Byte(Byte(inStr[i+2]))
    else
      Result := Result + '=';
    Inc(i, 3);
  end;
end;

Function EncodeBase64Mas(inStr:Array Of Byte):String;
Var
  I:Integer;
Begin
  I:=0;
  Result:='';
  While I<Length(InStr) Do
  Begin
    Result := Result + Encode_Byte(inStr[i] shr 2);
    Result := Result + Encode_Byte((inStr[i] shl 4) or (inStr[i+1] shr 4));
    If I+1<=Length(inStr) then
      Result := Result + Encode_Byte((inStr[i+1] shl 2) or (inStr[i+2] shr 6))
    else
      Result := Result + '=';
    if i+2<Length(inStr) then
      Result := Result + Encode_Byte(inStr[i+2])
    else
      Result := Result + '=';
    Inc(i, 3);
  end;
end;

// Base64 decoding
function DecodeBase64(const CinLine: string): string;
const
  RESULT_ERROR = -2;
var
  inLineIndex: Integer;
  c: Char;
  x: SmallInt;
  c4: Word;
  StoredC4: array[0..3] of SmallInt;
  InLineLength: Integer;
begin
  Result := '';
  inLineIndex := 1;
  c4 := 0;
  InLineLength := Length(CinLine);

  while inLineIndex<=InLineLength do
  begin
    while (inLineIndex<=InLineLength) and (c4 < 4) do
    begin
      c := CinLine[inLineIndex];
      case c of
        '+'     : x := 62;
        '/'     : x := 63;
        '0'..'9': x := Ord(c) - (Ord('0')-52);
        '='     : x := -1;
        'A'..'Z': x := Ord(c) - Ord('A');
        'a'..'z': x := Ord(c) - (Ord('a')-26);
      else
        x := RESULT_ERROR;
      end;
      if x<>RESULT_ERROR then
      begin
        StoredC4[c4] := x;
        Inc(c4);
      end;
      Inc(inLineIndex);
    end;

    if c4 = 4 then
    begin
      c4 := 0;
      Result := Result + Char((StoredC4[0] shl 2) or (StoredC4[1] shr 4));
      if StoredC4[2] = -1 then Exit;
      Result := Result + Char((StoredC4[1] shl 4) or (StoredC4[2] shr 2));
      if StoredC4[3] = -1 then Exit;
      Result := Result + Char((StoredC4[2] shl 6) or (StoredC4[3]));
    end;
  end;
end;

Procedure DecodeBase64Mas(Const CinLine:String;Var InStr:Array Of Byte);
const
  RESULT_ERROR = -2;
var
  inLineIndex,Ind:Integer;
  c: Char;
  x: SmallInt;
  c4: Word;
  StoredC4: array[0..3] of SmallInt;
  InLineLength: Integer;
begin
  Ind:=0;
  inLineIndex := 1;
  c4 := 0;
  InLineLength := Length(CinLine);

  while inLineIndex<=InLineLength do
  begin
    while (inLineIndex<=InLineLength) and (c4 < 4) do
    begin
      c := CinLine[inLineIndex];
      case c of
        '+'     : x := 62;
        '/'     : x := 63;
        '0'..'9': x := Ord(c) - (Ord('0')-52);
        '='     : x := -1;
        'A'..'Z': x := Ord(c) - Ord('A');
        'a'..'z': x := Ord(c) - (Ord('a')-26);
      else
        x := RESULT_ERROR;
      end;
      if x<>RESULT_ERROR then
      begin
        StoredC4[c4] := x;
        Inc(c4);
      end;
      Inc(inLineIndex);
    end;

    if c4 = 4 then
    begin
      c4 := 0;
      InStr[Ind]:=(StoredC4[0] shl 2) or (StoredC4[1] shr 4);
      Inc(Ind);
      if StoredC4[2] = -1 then Exit;
      InStr[Ind]:=(StoredC4[1] shl 4) or (StoredC4[2] shr 2);
      Inc(Ind);
      if StoredC4[3] = -1 then Exit;
      InStr[Ind]:=(StoredC4[2] shl 6) or (StoredC4[3]);
      Inc(Ind);
    end;
  end;
  end;
end.
